;=====================================================================================
;
;	PRUEBAS.ASM		PRUEBAS con PIC 16F876A
;
;=====================================================================================
;	Notas:	
;=====================================================================================
;	Pruebas:
;=====================================================================================
        LIST    p=16F876A 		; PIC16F876A is the target processor
	#include "P16F876A.INC"		; Definiciones del micro
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC
;=====================================================================================
;	Archivo				; Descripcin			Impreso
;=====================================================================================
	#include "REGBITS.INC"  	; Bits de registros
	#include "RAMVARS.INC" 		; Variables RAM			
;=====================================================================================
	#include "DEFINES.INC" 		; Defines de uso general		
;=====================================================================================
; Estas declaraciones tambin pueden llevarse a "DEFINES.INC"
;
BOTON_1	EQU	0
BOTON_2	EQU	1
BOTON_3	EQU	2
LED_1	EQU	5
LED_2	EQU	6
LED_3	EQU	7
;=====================================================================================
	#include "MACROS.INC" 		; Macros de uso general			
;=====================================================================================
; Estas macros tambin pueden llevarse a "MACROS.INC"
;
PRENDE_LED macro bit
	bcf	PORTC, bit
	endm
;
APAGA_LED macro	bit
	bsf	PORTC, bit
	endm
;=====================================================================================
	org H'2100'			; Initialize EEPROM Data
	de "PRUE87XX__020708"		; NOMBRE[.ASM] Fecha ltima revision
	de "xxxxxxxxxxxxxxxx"		; Parametros adicionales
	de "xxxxxxxxxxxxxxxx"		; Parametros adicionales
	de "xxxxxxxxxxxxxxxx"		; Parametros adicionales
;=====================================================================================
	org	0
	clrf    PCLATH			; Ensure page bits are cleared
	goto	START
	org	4
	goto	atenin
;=====================================================================================
START
	clrf	DEBUG		; 0: funcionamiento normal
	nop			; Para editar DEBUG desde el watch

	call	inicio		; Configura el estado inicial
	APAGA_LED	LED_1	; Led apaga en ALTO
	APAGA_LED	LED_2	; Led apaga en ALTO
	APAGA_LED	LED_3	; Led apaga en ALTO

main	; Comienzo del lazo principal

	call	botones		; Monitorea estado de los botones

	call	reloj		; Controla el paso del tiempo
				; y setea bits del portB

	goto	main		; Vuelve al inicio del lazo infinito

;=====================================================================================
botones	; Mide los estados digitales de los botones
	; Los botones son activos en BAJO

	btfss	PORTC, BOTON_1
	goto	funcion1

	btfss	PORTC, BOTON_2
	goto	funcion2

	btfss	PORTC, BOTON_3
	goto	funcion3

	return
;---------------------------------------
funcion1
	nop
salir_1	
	PRENDE_LED	LED_1	; Led prende en BAJO
	btfss	PORTC, BOTON_1	; Espera hasta que se libere el botn
	goto	salir_1
	APAGA_LED	LED_1	; Led apaga en ALTO
	return
;---------------------------------------
funcion2
	btfss	PORTC, LED_2	; Analiza estado anterior
	goto	apaga2
prende2	; Si estaba apagado, prende
	PRENDE_LED	LED_2	; Led prende en BAJO
	goto	salir_2
apaga2	; Si estaba prendido, apaga
	APAGA_LED	LED_2	; Led apaga en ALTO
	goto	salir_2	
salir_2	
	btfss	PORTC, BOTON_2	; Espera hasta que se libere el botn
	goto	salir_2
	return
;---------------------------------------
funcion3
	btfss	PORTC, LED_3	; Analiza estado anterior
	goto	apaga3
prende3	; Si estaba apagado, prende todos
	PRENDE_LED	LED_1	; Led prende en BAJO
	PRENDE_LED	LED_2	; Led prende en BAJO
	PRENDE_LED	LED_3	; Led prende en BAJO
	goto	salir_3
apaga3	; Si estaba prendido, apaga todos
	APAGA_LED	LED_1	; Led apaga en ALTO
	APAGA_LED	LED_2	; Led apaga en ALTO
	APAGA_LED	LED_3	; Led apaga en ALTO
	goto	salir_3
salir_3	
	btfss	PORTC, BOTON_3	; Espera hasta que se libere el botn
	goto	salir_3
	return
;---------------------------------------
funcion4
	return
;=====================================================================================
;	#include "UTILES.INC"	; Archivo con la implementacion de otras funciones
	#include "ATENIN.INC" 	; Atencin de interrupciones	
	#include "INICIO.INC"	; Configuracin inicial del micro
	#include "RELOJ_.INC"	; Sincronismo general
;=====================================================================================
;funcion_
;	btfss	FLAGS, PULSO_1s	; Analiza estado anterior
;	goto	apaga1s
;prend_p	; Si estaba apagado, prende
;	bcf	FLAGS, PULSO_1s	; Activa pulsador de 1 seg
;	goto	salir_p
;apaga_p	; Si estaba prendido, apaga
;	bsf	FLAGS, PULSO_1s	; Desactiva pulsador de 1 seg
;	goto	salir_p	
;salir_p	
;	btfss	PORTC, BOTON_1	; Espera hasta que se libere el botn
;	goto	salir_p
;	return
;=====================================================================================
	END
;=====================================================================================