;=========================================================================
inicio	
	banksel	PORTA		; Banco normal
	call	clrgie		; Global
	clrf	INTCON		; Deshablita todas las interrupciones
	clrwdt				; Limpia el contador del Watch Dog Timer

;====================================================================================
;
;       Detalle de las entradas analgicas
;       ----------------------------------
;
;			 _____      _____
;			|     \____/   
;		 RESET -| 1
;       EA:	   RA0 -| 2 - AN0
;       EA:	   RA1 -| 3 - AN1
;       	   RA2 -| 4 - AN2
;       EA:	   RA3 -| 5 - AN3
;       	   RA4 -| 6
;       	   RA5 -| 7 - AN4
;			|
;
;====================================================================================
; ADCON1 - Configuracion de entradas analogicas/digitales			     
;====================================================================================
;   movlw   b'00000000'     ; Digi: -                   Ana:(7,6,5),4,3,2,1,0
;   movlw   b'00001001'     ; Digi:(7,6)                Ana:(5),4,3,2,1,0
;   movlw   b'00000010'     ; Digi:(7,6),5              Ana:4,3,2,1,0
;   movlw   b'00000100'     ; Digi:(7,6),5,4,2          Ana:3,1,0
;   movlw   b'00001110'     ; Digi:(7,6),5,4,3,2,1      Ana:0
;   movlw   b'0000011x'     ; Digi:(7,6),5,4,3,2,1,0
;====================================================================================
; PORTA:  / - / - / - / - / - / - / - / TERMOCUPLA /				     
;------------------------------------------------------------------------------------
;MSKADC	EQU	b'00000100' ;=ADCON1 - PORTA= --ADAAAA Just.10 bits a izq (LSB=0)
;MSKTRS	EQU	b'00011111' ;=TRISA  - PORTA= --SEEEEE
;------------------------------------------------------------------------------------

iniPORT	; Puertos de E/S
	; PORTA
	movlw	b'00011111'	; Todas entradas y RA5=salida
	banksel	TRISA
	movwf	TRISA		; Configura puerto de E/S
	movlw	b'00000100'
	banksel	ADCON1
	movwf	ADCON1		; Configura Ana/Digi
	; PORTB
	movlw	b'00000000'	; Todas salidas a leds
	banksel	TRISB
	movwf	TRISB		; Configura puerto de E/S
	; PORTC
	movlw	b'00000111'	; Entradas:0-3 - Salidas: 4-7
	movwf	TRISC		; Configura puerto de E/S

iniTEMP	; Temporizacion del TMR0 (Fosc=20Mhz, Tosc=50ns,  PasoTMR0=200ns)
	; #define 	TIMINI	d'131'		
	; TMR0 desborda cada 125 pasos = instrucciones
	;----------------------------------------------------------------
;	movlw   b'10001000'	; PU:NO, EDG=F, PRE:W, F:1/1, PasoTMR0=1 us
;	movlw   b'10000000'	; PU:NO, EDG=F, PRE:T, F:1/2, PasoTMR0=2 us
	movlw   b'11000000'	; PU:NO, EDG=R, PRE:T, F:1/2, PasoTMR0=2 us
	banksel	OPTION_REG
	movwf   OPTION_REG
	; TIMINI=131
	;
	; F:1/1, 1us/instruccin 1 us * 125 = 125 us
	; 1us * 125 = 125 us por cada desborde del TMR0
	; 1 desborde  de TMR0 = 125 us = T ms corto medible
	; 8 desbordes de TMR0 = 1 ms
	;
	; F:1/2, 2us/instruccin
	; 2us * 125 = 250 us por cada desborde del TMR0
	; 1 desborde  de TMR0 = 250 us = T ms corto medible
	; 4 desbordes de TMR0 = 1 ms (NDSBT0=4)
	;
	banksel	TMR0
	clrf	TMR0		; Pone el Timer0 en CERO = 0
	RESET_TMR0		; Pone el Timer0 en TIMINI = 131

	; Interrupciones externas
	banksel	PIR1
	clrf	PIR1		; Limpia flags
	banksel	PIR2
	clrf	PIR2		; Limpia flags

	clrf	PORTA		; Limpia las salidas
	clrf	PORTB		; Limpia las salidas
	clrf	PORTC		; Limpia las salidas

	; Habilitacin final de interrupciones
	HABILITA_TMR0		; Del timer0
	HABILITA_GLOBAL		; Global
	clrf	FLAGS		; Deshabilita medicion y borra flag de desborde

conts	; Contadores para el reloj 
	movlf	NDSBT0,DT_DSBT0		; Hacen 1 ms
	recarga	MAX001ms,DT_001ms	; Hacen 10 ms
	recarga	MAX010ms,DT_010ms	; Hacen 100 ms
	recarga	MAX100ms,DT_100ms	; Hacen 1 seg
	movlf	MAX001sg,DT_001sg	; Hacen 10 seg
	movlf	MAXIDLE,TIDLE		; Tiempo antes de sleep

	return
;=========================================================================

