;=========================================================================
;	MACROS
;=========================================================================
recarga	macro	LITERAL, FILE
	movlw	0x02
	btfss	DEBUG,0
	movlw	LITERAL
	movwf	FILE
	endm
;=========================================================================
movlf	macro	LITERAL, FILE
	movlw	LITERAL
	movwf	FILE
	endm
;=========================================================================
movff	macro	FILE1,	FILE2
	movf	FILE1,W
	movwf	FILE2
	endm
;=========================================================================
; If FILE = LITERAL  then skip
feqls	macro	FILE,LITERAL
	movfw	FILE
	sublw	LITERAL		; W = LITERAL - FILE
	btfss	STATUS,Z
	endm

; If FILE <> LITERAL  then skip
fnels	macro	FILE,LITERAL
	movfw	FILE
	sublw	LITERAL		; W = LITERAL - FILE
	btfsc	STATUS,Z
	endm

; If FILE < LITERAL then skip
fltls	macro	FILE,LITERAL
	movlw	LITERAL
	subwf	FILE,W		; W <- FILE - LITERAL
	btfsc	STATUS,C
	; 	FILE >= LITERAL => C=1
	; 	FILE <  LITERAL => C=0
	endm

; If FILE >= LITERAL then skip
fgels	macro	FILE,LITERAL
	movlw	LITERAL
	subwf	FILE,W		; W <- FILE - LITERAL
	btfss	STATUS,C
	; 	FILE <  LITERAL => C=0
	; 	FILE >= LITERAL => C=1
	endm

; If FILE > LITERAL then skip
fgtls	macro	FILE,LITERAL
	movfw	FILE
	sublw	LITERAL		; W <- LITERAL - FILE
	btfsc	STATUS,C
	; 	FILE <= LITERAL	=> C=1
	; 	FILE >  LITERAL => C=0
	endm

; If FILE <= LITERAL then skip
flels	macro	FILE,LITERAL
	movfw	FILE
	sublw	LITERAL		; W <- LITERAL - FILE
	btfss	STATUS,C
	; 	FILE >  LITERAL => C=0
	; 	FILE <= LITERAL	=> C=1
	endm

;=========================================================================
; If FILE1 = FILE2 then skip
f1eqf2s	macro	FILE1,	FILE2
	movfw	FILE1
	subwf	FILE2,W		; W <- FILE2 - FILE1
	btfss	STATUS,Z
	endm

; If FILE1 <> FILE2 then skip
f1nef2s	macro	FILE1,	FILE2
	movfw	FILE1
	subwf	FILE2,W		; W <- FILE2 - FILE1
	btfsc	STATUS,Z
	endm

; If FILE1 <= FILE2 then skip
f1lef2s	macro	FILE1,	FILE2
	movfw	FILE1
	subwf	FILE2,W		; W <- FILE2 - FILE1
	btfss	STATUS,C
	; 	FILE1 <= FILE2 => C=1
	; 	FILE1 >  FILE2 => C=0
	endm

; If FILE1 > FILE2 then skip
f1gtf2s	macro	FILE1,	FILE2
	movfw	FILE1
	subwf	FILE2,W		; W <- FILE2 - FILE1
	btfsc	STATUS,C
	; 	FILE1 <= FILE2 => C=1
	; 	FILE1 >  FILE2 => C=0
	endm

; If FILE1 >= FILE2 then skip
f1gef2s	macro	FILE1,	FILE2
	movfw	FILE2
	subwf	FILE1,W		; W <- FILE1 - FILE2
	btfss	STATUS,C
	; 	FILE1 >= FILE2 => C=1
	; 	FILE1 <  FILE2 => C=0
	endm

; If FILE1 < FILE2 then skip
f1ltf2s	macro	FILE1,	FILE2
	movfw	FILE2
	subwf	FILE1,W		; W <- FILE1 - FILE2
	btfsc	STATUS,C
	; 	FILE1 >= FILE2 => C=1
	; 	FILE1 <  FILE2 => C=0
	endm

;=========================================================================
movwf_	macro	FILE
	movwf	BAFER2		; Origen
	movlw	d'8'
	movwf	BAFER3		; Contador
	rrf	BAFER2,F
	rlf	BAFER4,F	; Destino temporario
	decfsz	BAFER3,F
	goto	$-3
	movf	BAFER4,W
	movwf	FILE		; Destino final
	endm
;=========================================================================
m_push	macro
	; Salva registros de trabajo 
	; ---------------------------
	banksel	W_TEMP
	movwf	W_TEMP 		; Copy W to TEMP register
	swapf	STATUS,W 	; Swap status to be saved into W
	clrf	STATUS 		; bank 0, regardless of current bank, Clears IRP,RP1,RP0
	movwf	STATUS_TEMP 	; Save STATUS (swapped) to bank zero STATUS_TEMP register
	movf	PCLATH, W 	; Only required if using pages 1, 2 and/or 3
	movwf	PCLATH_TEMP 	; Save PCLATH into PCLATH_TEMP
 	clrf	PCLATH 		; Page zero, regardless of current page
	endm
;-------------------------------------------------------------------------
m_pop	macro
	; Repone registros de trabajo
	; ---------------------------
	movf	PCLATH_TEMP, W 	; Restore PCLATH
	movwf	PCLATH 		; Move W into PCLATH
	swapf	STATUS_TEMP,W 	; Swap STATUS_TEMP register into W
				; (sets bank to original state)
	movwf	STATUS 		; Move W into STATUS register
	swapf	W_TEMP,F 	; Swap W_TEMP
	swapf	W_TEMP,W
	endm
;=========================================================================
; Recarga contador de 40 pasos de 250 us
; Para relojes de 4 MHz
RESET_CNT250u	macro TIMES
	movlw	TIMES	; d'40'
	btfsc	DEBUG,0
	movlw	d'1'		; DEBUG=1
	movwf	CNT250u
	endm
; Recarga contador de 200 pasos de 50 us
; Para relojes de 20 MHz f:1/2
RESET_CNT50us	macro TIMES
	movlw	TIMES	; d'100'
	btfsc	DEBUG,0
	movlw	d'1'		; DEBUG=1
	movwf	CNT50us
	endm
; Recarga contador de 100 pasos de 10 ms
RESET_CNT1ms	macro TIMES
	movlw	TIMES	; d'100'
	btfsc	DEBUG,0
	movlw	d'1'		; DEBUG=1
	movwf	CNT1ms
	endm
; Recarga contador de 100 pasos de 10 ms
RESET_CNT10ms	macro TIMES
	movlw	TIMES	; d'100'
	btfsc	DEBUG,0
	movlw	d'1'		; DEBUG=1
	movwf	CNT10ms
	endm
; Recarga contador de 100 pasos de 10 ms
RESET_CNT100ms	macro TIMES
	movlw	TIMES	; d'100'
	btfsc	DEBUG,0
	movlw	d'1'		; DEBUG=1
	movwf	CNT100ms
	endm
;=========================================================================
; Recarga 10 pasos
RESET_SEGUNDOS	macro TIMES
	movlw	TIMES	; d'10'
	btfsc	DEBUG,0
	movlw	d'10'		; DEBUG=1
	movwf	SEGUNDOS
	endm
; Recarga 6 pasos
RESET_DEC_SEG	macro TIMES
	movlw	TIMES	; d'6'
	btfsc	DEBUG,0
	movlw	d'6'		; DEBUG=1
	movwf	DEC_SEG
	endm
; Recarga 10 pasos
RESET_MINUTOS	macro	TIMES
	movlw	TIMES	; d'10'
	btfsc	DEBUG,0
	movlw	d'2'		; DEBUG=1
	movwf	MINUTOS
	endm
; Recarga 6 pasos
RESET_DEC_MIN	macro TIMES
	movlw	TIMES 	; d'6'
	btfsc	DEBUG,0
	movlw	d'2'		; DEBUG=1
	movwf	DEC_MIN
	endm
; Recarga 10 pasos
RESET_HORAS	macro TIMES
	movlw	TIMES	; d'10'
	btfsc	DEBUG,0
	movlw	d'2'		; DEBUG=1
	movwf	HORAS
	endm
; Recarga 2 pasos
RESET_DEC_HOR	macro TIMES
	movlw	TIMES	; d'10'
	btfsc	DEBUG,0
	movlw	d'2'		; DEBUG=1
	movwf	DEC_HOR
	endm
;=========================================================================
ENTRADA_POR	macro	REG, BIT
	bsf	REG,BIT
	endm
;------------------------------------------------------------
SALIDA__POR	macro	REG, BIT
	bcf	REG,BIT
	endm
;------------------------------------------------------------
ENVIA_SERIE	macro	DATO
	movf	DATO,W		; Toma el dato de la memoria
	movwf	DATOSER		; Carga el dato en el bufer
	call	tx_ser		; Transmite el valor por el puerto serial
	endm
;=====================================================================================
L_RAM	macro			; La direccion est en WREG
	movwf	FSR		; 
	movf 	INDF,W		; Devuelve DATO en WREG
	endm
;
G_RAM	macro	VALOR		; La direccion destino est en WREG
	movwf	FSR
	movf	VALOR,W		; El valor a guardar
	movwf 	INDF
	endm
;------------------------------------------------------------
BANCO_0	macro	
	bcf	STATUS,RP1
	bcf	STATUS,RP0
	endm
;------------------------------------------------------------
BANCO_1	macro
	bcf	STATUS,RP1
	bsf	STATUS,RP0
	endm
;------------------------------------------------------------
BANCO_2	macro
	bsf	STATUS,RP1
	bcf	STATUS,RP0
	endm
;------------------------------------------------------------
BANCO_3	macro
	bsf	STATUS,RP1
	bsf	STATUS,RP0
	endm
;=========================================================================
RESET_TMR0 macro	; TIMINI=d'131'
	;   25 uS por desborde (F=1)
	;   50 uS por desborde (F=1/2)
	; N*25 uS por desborde (F=1/N)
;	banksel TMR0
	movf	TMR0,W
	addlw	TIMINI
;	btfsc	DEBUG,0
;	movlw	d'150'		; DEBUG=1
	movwf	TMR0
;	banksel PORTA		; Banco 0
	endm
;=====================================================================================
RESETSAL macro 
 local	SIMUX
 local	NOMUX
 local	XTMUX
 local	CKIN_ENT
 local	END_CKIN

;Configuracion del PORTA
	banksel	CANALESV
	btfss	CANALESV,MUXTON
	goto	NOMUX
SIMUX
	banksel	MSKAPM
	movlw	MSKAPM
	banksel	TRISA
	movwf	TRISA
	banksel	MSKADM
	movlw	MSKADM
	banksel	ADCON1
	movwf	ADCON1
	goto	XTMUX
NOMUX
	banksel	MSKAPS
	movlw	MSKAPS
	banksel	TRISA
	movwf	TRISA
	banksel	MSKADS
	movlw	MSKADS
	banksel	ADCON1
	movwf	ADCON1
XTMUX

;Configuracion del PORTB

	banksel	TRISB
	clrf	TRISB	; Todas salidas

;Configuracion del PORTC

	banksel	TRISC
	bsf	TRISC,PULSIN	; Entrada de seal
	bsf	TRISC,RC7	; Entrada RS232
	bsf	TRISC,CLKIN	; Entrada por defecto

#IFDEF _DISPLAY_TEXTO_ACTIVO
	banksel	MODOSALD
	btfsc	MODOSALD,DISGRA
	goto	CKIN_SAL
	btfsc	MODOSALD,DISTEX
	goto	CKIN_SAL
	goto	END_CKIN
CKIN_SAL
	banksel	TRISC
	bcf	TRISC,CLKIN	; Hay display asignado
END_CKIN
#ENDIF	;_DISPLAY_TEXTO_ACTIVO
		
#IFDEF _DISPLAY_TEXTO_ACTIVO
	banksel	MODOSALD
	btfss	MODOSALD,DISTEX
	goto	$+3
	call	RST2x16
	call	TITULO_TEXT
#ENDIF	;_DISPLAY_TEXTO_ACTIVO

#IFDEF _DISPLAY_GRAFICO_ACTIVO
	banksel	MODOSALD
	btfss	MODOSALD,DISGRA
	goto	$+3
	call	RESETDG
;	call	TITULO_TEXT
#ENDIF	;_DISPLAY_GRAFICO_ACTIVO

#IFDEF _DISPLAY_7_SEGMENTOS
	call	RESET_7S
#ENDIF	;_DISPLAY_7_SEGMENTOS

	banksel	PORTA
	
	endm
;=====================================================================================
RESETTEC macro
#IFDEF _TECLADO_ACTIVO
	bcf	FLAGS,TECLADO	; Sealiza
	bsf	TRISA,5		; Apaga el led del boton
#ENDIF
	endm
;=====================================================================================
RESETCOM  macro
#IFDEF	_COMUNICACION_RS232_ACTIVA
	clrf	FLAGCOM		; Inicia flujo de decisiones
#ENDIF
	endm
;=====================================================================================
esperar	macro	CANTIDAD, UNIDAD
  local	cuenta_us
  local	cuenta_ms
  local	cuenta_s
  local	finmacrotimer

	btfsc	DEBUG,0
	goto	finmacrotimer
	
	movlw	CANTIDAD
	movlw	UNIDAD
	clrf	TIMERS
	bsf	TIMERS,UNIDAD
	btfsc	TIMERS,0	; Cuenta us
	goto	cuenta_us
	btfsc	TIMERS,1	; Cuenta ms
	goto	cuenta_ms
	btfsc	TIMERS,2	; Cuenta s
	goto	cuenta_s
	goto	finmacrotimer

cuenta_us
	movlw	CANTIDAD
	call	delay_Nu
	goto	finmacrotimer

cuenta_ms
	movlw	CANTIDAD
	call	delay_Nm
	goto	finmacrotimer

cuenta_s
	movlw	CANTIDAD
	call	delay_Ns
	goto	finmacrotimer

finmacrotimer
	endm
;=====================================================================================
;ConvH2D macro 	HVAL, CEN, DEC, UNI
;	movf	HVAL,W
;	call	DevCens
;	movwf	CEN
;	movf	HVAL,W
;	call	DevDecs
;	movwf	DEC
;	movf	HVAL,W
;	call	DevUnis
;	movwf	UNI
;	endm
;=====================================================================================
