;=========================================================================
;	RAM
;=========================================================================
; Para el 16F873/4/6/7
BK0_RAM	EQU	H'20'		; Inicio Banco 0 del area RAM (d'32')
BK0_MAX	EQU	H'6F'		; Fin    Banco 0 del area RAM  (d'127')
BKS_RAM	EQU	H'70'		; Inicio Banco Shared (Compartido)
BKS_MAX	EQU	H'7F'		; Fin    Banco Shared (Compartido)

; Para el 16F873/4
;BK1_RAM	EQU	H'A0'	; Inicio Banco 1 del area RAM (d'---')
;BK1_MAX	EQU	H'FF'	; Fin    Banco 1 del area RAM (d'---')

; Para el 16F876/7
BK1_RAM	equ	H'A0'		; Inicio Banco 1 del area RAM (d'---')
BK1_MAX	equ	H'EF'		; Fin    Banco 1 del area RAM (d'---')
BK2_RAM	equ	H'120'		; Inicio Banco 2 del area RAM (d'---')
BK2_MAX	equ	H'16F'		; Fin    Banco 2 del area RAM (d'---')
BK3_RAM	equ	H'1A0'		; Inicio Banco 3 del area RAM (d'---')
BK3_MAX	equ	H'1EF'		; Fin    Banco 3 del area RAM (d'---')
;-------------------------------------------------------------------------
	cblock	BK0_RAM

		DEBUG		; Para pruebas previas
		FLAGS		; Indicadores de estado de flags
		TICS		; Indicadores de estado de tics
		TIDLE		; Contador para ir a sleep

		REFEREN_L	; Valor de temperatura de referencia (registro bajo)
		REFEREN_H	; Valor de temperatura de referencia (registro alto)
		NROVAL_L	; Valor de temperatura medido (registro bajo)
		NROVAL_H	; Valor de temperatura medido (registro alto)

		DT_DSBT0	; Contador de desbordes de TMR0
		DT_001ms	; Contador de pasos de 1 ms
		DT_010ms	; Contador de pasos de 10 ms
		DT_100ms	; Contador de pasos de 100 ms

		DT_001sg	; Contador de pasos de 1 seg
		AUXPUL		; Contador para sumar las hxadas
;		RANGO 		; ???
	

		UNI_7SEG	; Unidades del display de 7 segmentos
		DEC_7SEG	; Decenas  del display de 7 segmentos
		CEN_7SEG	; Centenas del display de 7 segmentos
		MIL_7SEG	; Millares del display de 7 segmentos

		CNT50us		; Recarga 200 pasos con 20 MHz
		CNT1ms
		CNT10ms
		CNT100ms

		TIMERS		; Flags de esperas de tiempo
		W_Nt		; Contador regresivo hasta N unidades de tiempo
		W_1s		; Contador regresivo hasta 1s
		W_12ms		; Contador regresivo hasta 100ms
		W_11ms		; Contador regresivo hasta 10ms
		W_1ms		; Contador regresivo hasta 1ms
		W_12us		; Contador regresivo hasta 100us
		W_11us		; Contador regresivo hasta 10us

		BAFER1		; EsperaT1
		BAFER2
		BAFER3
		BAFER4

		T1		; R64 - De las rutinas de conversion Hex -> Dec
		W2		; R65 - 

		SHARED		; R91 - NO USAR
		W_TEMP		; R92 - Registros auxiliares
		STATUS_TEMP	; R93 -   para guardar el entorno
		PCLATH_TEMP	; R94 -   durante atenin
		W_TEMP2		; R95 - Registros auxiliares

		; Nro Registros = ?

	endc
;-------------------------------------------------------------------------
